![Hanappe logo](/hanappe_logo.png)

# Hanappe Projects

## Introduction
Open source framework for [Moai SDK](https://github.com/moai/moai-dev).

## Setup

This is not required if it is already installed.

	# Install MOAI SDK, Apache Ant
	# For details, see the moai-dev.
	# 1.5-stable branch or 1.5.2 Release.

	# Download Hanappe
	cd <install_path>
	git clone https://github.com/makotok/Hanappe.git

## Run Samples
	
### Mac OSX

Please run the "run_osx.sh" file.

	cd <install_path>/Hanappe/projects/flower-sample
	./run_osx.sh
	
	cd <install_path>/Hanappe/projects/hanappe-sample
	./run_osx.sh

### Windows

Please run "run_win.bat" file.

	cd <install_path>\Hanappe\projects\flower-sample
	run_win.bat
	
	cd <install_path>\Hanappe\projects\hanappe-sample
	run_win.bat
	
## SDK Version
I have been tested on the following versions.
However, it supports the latest version basically.

* Moai SDK Release 1.5.2

## Tools Version
Tool version being used by the Hanappe is as follows.
You are not necessarily required.

* [Lua Development Tools 0.9](http://www.eclipse.org/koneki/ldt/)
* [Apache Ant version 1.9.3](http://ant.apache.org/)
* [LDoc version 1.3.3](https://github.com/stevedonovan/LDoc)

## Tests
The terminal work as follows.

* Mac OSX 10.9.1
* iPhone Simulator
* Windows 7
* Android 4.1 (Nexus 7)

## Projects

* [Hanappe Framework](/projects/hanappe-framework)  
This project is a framework for MoaiSDK.
I have developed to many features.

* [Hanappe Samples](/projects/hanappe-samples)  
This is a sample code of the Hanappe Framework.

* [Flower Library](/projects/flower-library)  
This library has improved easy-to-use Hanappe Framework.
There is no dependency, it is lightweight and easy to handle library.

* [Flower Samples](/projects/flower-samples)  
This is a sample code of the Flower Library.

* [Flower Extensions](/projects/flower-extensions)  
This project will extend the Flower Library.

## Wiki

Please refer to the following.
It is okay to freely edit the wiki.

* [Home](https://github.com/makotok/Hanappe/wiki)
* [Flower](https://github.com/makotok/Hanappe/wiki/Flower-Library)
* [Hanappe](https://github.com/makotok/Hanappe/wiki/Hanappe-Framework)

## Branch

Hanappe branches are there are the following.

* master ... Master branch. Stable.
* dev ... Development branch. Unstable.

## Contribution

See [CONTRIBUTING.md](/CONTRIBUTING.md).

## Release Notes

See [NOTES.md](/NOTES.md).

## Links

* [spine-moai](https://github.com/tangerinagames/spine-moai)
It was implemented by TangZero.

## Showcase

Here is a list of games that Hanappe is used.

* [Gem Collapse 2](http://getmoai.com/forums/gem-collapse-2-made-with-moai-t1822/)
* [Gem Swipe](http://getmoai.com/forums/gem-swipe-by-meyume-t1908/)
* [Mahjong Skies](http://getmoai.com/forums/mahjong-skies-t1896/)

## Contact
If there is a demand of bug fixes and feature improvements, please register to Github.  
If you want to exchange mail directly, please check my profile.

## Memo
I my English is not good.
Study.
